package net.t2code.opsecurity.check;

import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Language;
import net.t2code.opsecurity.config.permissionWhitelist.PermissionWhitelist;
import net.t2code.opsecurity.events.Events;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.BungeeSenderReceiver;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.commands.T2Ccmd;
import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.Map;

public class PermissionCheck {
    public static Boolean onCheck(Player player, Boolean join, String debug) {
        if (!PermissionWhitelist.enable.valueBoolean) return false;
        for (String perm : PermissionWhitelist.permissions.valueStringList) {
            if (!player.hasPermission(perm)) return false;
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] check Permission: " + perm);
            if (permWhitelist(player, debug)) return false;
            Bukkit.getScheduler().runTask(Main.getPlugin(), new Runnable() {
                @Override
                public void run() {
                    execute(player, join, perm, debug);
                }
            });
            return true;
        }
        return false;
    }

    private static void execute(Player player, Boolean join, String perm, String debug) {
        if (join)
            T2Csend.console("[" + debug + "]" + Language.permissionWhitelistNotifyKick.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        if (Config.notifyJoinWarning.valueBoolean && join) {
            if (Config.notifyBungee.valueBoolean) {
                BungeeSenderReceiver.sendToBungee(Language.permissionWhitelistNotifyOnJoin.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
            } else
                Events.notifyPlayer(Language.permissionWhitelistNotifyOnJoin.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        }

        if (PermissionWhitelist.playerWithPermissionKick.valueBoolean) {
            if (Config.kickCustomCommand.valueBoolean) {
                T2Ccmd.console(Config.kickCommand.valueString.replace("[perm]", perm).replace("[player]", player.getName()).replace("[reason]", Language.permissionWhitelistKick.value));
            } else player.kickPlayer(Language.permissionWhitelistKick.value);
            T2Csend.console("[" + debug + "]" + Language.permissionWhitelistNotifyKick.value.replace("[player]",
                    player.getName()).replace("[perm]", perm).replace("[uuid]", String.valueOf(player.getUniqueId())));
        }
        if (PermissionWhitelist.customCommandsEnable.valueBoolean) {
            for (String cmd : PermissionWhitelist.customCommandsCommands.valueStringList) {
                T2Ccmd.console(cmd.replace("[player]", player.getName()).replace("[perm]", perm));
            }
        }
    }

    public static Boolean permWhitelist(Player player, String debug) {

        for (Map.Entry<String, PlayerObject> playerObject : PlayerCache.getPermissionHashMap().entrySet()) {
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] --------- " + player.getName() + " ---------");
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist playerObject Name: " + playerObject.getValue().playerName);
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player Name: " + player.getName());
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist playerObject UUID: " + playerObject.getValue().uuid);
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player UUID: " + player.getUniqueId().toString().replace("-", ""));
            if (playerObject.getValue().playerName.equals(player.getName()) && playerObject.getValue().uuid.equals(player.getUniqueId().toString().replace("-", ""))) {
                T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player on list!");
                T2Cdebug.debug(Main.getPlugin(), "");
                return true;
            } else T2Cdebug.debug(Main.getPlugin(), "");
        }
        return false;
    }
}
