package net.t2code.opsecurity.command;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.check.OpCheck;
import net.t2code.opsecurity.config.FileSelect;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Language;
import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.system.Permissions;
import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class Commands {

    public static void help(CommandSender sender){
        if (!sender.hasPermission(Permissions.help)) {
            T2Csend.sender(sender, Language.noPermissionForOpSec.value);
            return;
        }
        //todo to language file

        sender.sendMessage(Util.getPrefix() + " §8----- §2OP§4Security §chelp §8-----");
        sender.sendMessage(Util.getPrefix());
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity reload§8' §eReload the Plugin.");
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity help§8' §eOpens this help.");
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity info§8' §eCall the info about §2OP§4Security§e.");
        sender.sendMessage(Util.getPrefix());
        sender.sendMessage(Util.getPrefix() + " §8----------------------------");
    }

    public static void mainCommand(CommandSender sender) {
        if (Config.onlyOPcanUseThePlugin.valueBoolean) {
            if (!sender.isOp()) {
                sender.sendMessage(Util.getPrefix() + "§cOnly OPs can use OPSecurity!");
                return;
            }
        }
        if (sender.hasPermission(Permissions.help)) {
            help(sender);
        } else {
            sender.sendMessage(Util.getPrefix() + " §cYou do not have permission for OPSecurity! §7<" + Permissions.help + ">");
        }
    }

    public static void reload(CommandSender sender) {
        if (!sender.hasPermission(Permissions.reload)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.reload + ">");
            return;
        }
        if (sender instanceof Player) {
            Player player = (Player) sender;
            if (Config.onlyOPcanUseThePlugin.valueBoolean) {
                String debug = T2Cdebug.debugCode();
                if (!OpCheck.opWhitelist(player,debug)) {
                    sender.sendMessage(Util.getPrefix() + " §4You are not on the Whitelist!"); // todo
                    return;
                }
            }
            T2Csend.player(player, Language.reloadStart.value);
        }
        if (sender instanceof Player) T2Csend.player((Player) sender, Language.reloadEnd.value);
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §6Plugin reload...");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
       // Load.onLoad(Main.getPlugin(),Main.getAutor(),Main.getVersion());
        FileSelect.selectConfig();
        FileSelect.selectLanguage();
        FileSelect.selectOpWhitelist();
        FileSelect.selectPermissionWhitelist();
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §2Plugin successfully reloaded.");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
    }

    public static void info(CommandSender sender) {
        if (!sender.hasPermission(Permissions.info)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.info + ">");
            return;
        }
        T2Ctemplate.sendInfo(sender,Main.getPlugin(),Util.getSpigotID(),Util.getDiscord(),Util.getInfoText());
    }
}
