package net.t2code.opsecurity.config.permissionWhitelist;

import net.t2code.opsecurity.enums.ConfigParam;

import java.util.Arrays;
import java.util.List;

public enum PermissionWhitelist {
    enable("permissionWhitelist.enable", false, ConfigParam.BOOLEAN),
    playerWithPermissionKick("permissionWhitelist.playerWithPermissionKick", true, ConfigParam.BOOLEAN),
    permissions("permissionWhitelist.permissions", Arrays.asList("*", "t2c.opsecurity.admin"), ConfigParam.STRINGLIST),
    customCommandsEnable("permissionWhitelist.customCommands.enable", false, ConfigParam.BOOLEAN),
    customCommandsCommands("permissionWhitelist.customCommands.commands", Arrays.asList("lp user [player] permission unset *", "lp user [player] permission unset t2c.opsecurity.admin")
            , ConfigParam.STRINGLIST),
    player("permissionWhitelist.whitelist", "permissionWhitelist.whitelist.KEY.name", "permissionWhitelist.whitelist.KEY.uuid", "PlayerName", "00000000000000000000000000000000", ConfigParam.PLAYERLIST);

    public String path;
    public String pathPlayerListPath;
    public String pathPlayerName;
    public String pathPlayerUuid;
    public String valuePlayerName;
    public String valuePlayerUuid;
    public List<String> valueStringList;
    public Boolean valueBoolean;
    public ConfigParam cEnum;

    PermissionWhitelist(String listPath, String pathPlayerName, String pathUuid, String playerName, String uuid, ConfigParam cEnum) {
        this.pathPlayerListPath = listPath;
        this.pathPlayerName = pathPlayerName;
        this.pathPlayerUuid = pathUuid;
        this.valuePlayerName = playerName;
        this.valuePlayerUuid = uuid;
        this.cEnum = cEnum;
    }

    PermissionWhitelist(String path, List<String> value, ConfigParam cEnum) {
        this.path = path;
        this.valueStringList = value;
        this.cEnum = cEnum;
    }

    PermissionWhitelist(String path, Boolean value, ConfigParam cEnum) {
        this.path = path;
        this.valueBoolean = value;
        this.cEnum = cEnum;
    }
}
