package net.t2code.opsecurity.system;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.command.CmdExecuter;
import net.t2code.opsecurity.config.FileSelect;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.config.Converter;
import net.t2code.opsecurity.events.Events;
import net.t2code.opsecurity.events.OpCommand;
import net.t2code.opsecurity.events.PlugManCommand;
import net.t2code.opsecurity.check.Timer;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.register.T2Cregister;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import org.checkerframework.checker.units.qual.C;

import java.util.List;
import java.util.logging.Level;

public class Load {

    public static void onLoad(Main plugin, List<String> autor, String version) {
        long long_ = T2Ctemplate.onLoadHeader(Util.getPrefix(), autor, version, Util.getSpigot(), Util.getDiscord());
        try {
            Converter.convert();
        } catch (Exception ex) {
            plugin.getLogger().log(Level.SEVERE, ex.getMessage());
            ex.printStackTrace();
        }

        FileSelect.selectConfig();
        FileSelect.selectLanguage();
        FileSelect.selectOpWhitelist();
        FileSelect.selectPermissionWhitelist();

        plugin.getCommand("t2c-opsecurity").setExecutor(new CmdExecuter());

        T2Cregister.listener(new OpCommand(), plugin);
        T2Cregister.listener(new PlugManCommand(), plugin);
        T2Cregister.listener(new Events(), plugin);

        Timer.refreshTimer();
        Permissions.register();
        T2CupdateAPI.onUpdateCheck(plugin, Util.getPrefix(),Util.getGit(),Util.getSpigotID(),Util.getDiscord(), Config.updateCheckOnJoin.valueBoolean,
                Config.updateCheckSeePreReleaseUpdates.valueBoolean, Config.updateCheckTimeInterval.valueInt);
        Metrics.Bstats(plugin, Util.getBstatsID());
        T2Ctemplate.onLoadFooter(Util.getPrefix(), long_);
    }
}
